import { AmqpConnection } from '@golevelup/nestjs-rabbitmq';
import { Test, TestingModule } from '@nestjs/testing';
import { ConfigurationMessager } from '../../adapters/secondaries/configuration.messager';

const mockAmqpConnection = {
  publish: jest.fn().mockImplementation(),
};

describe('ConfigurationMessager', () => {
  let configurationMessager: ConfigurationMessager;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [],
      providers: [
        ConfigurationMessager,
        {
          provide: AmqpConnection,
          useValue: mockAmqpConnection,
        },
      ],
    }).compile();

    configurationMessager = module.get<ConfigurationMessager>(
      ConfigurationMessager,
    );
  });

  it('should be defined', () => {
    expect(configurationMessager).toBeDefined();
  });

  it('should publish a message', async () => {
    jest.spyOn(mockAmqpConnection, 'publish');
    await configurationMessager.publish('configuration.create.info', 'my-test');
    expect(mockAmqpConnection.publish).toHaveBeenCalledTimes(1);
  });
});
