import { ArgumentMetadata } from '@nestjs/common';
import { FindConfigurationByUuidRequest } from '../../../modules/configuration/domain/dtos/find-configuration-by-uuid.request';
import { RpcValidationPipe } from '../../pipes/rpc.validation-pipe';

describe('RpcValidationPipe', () => {
  it('should not validate request', async () => {
    const target: RpcValidationPipe = new RpcValidationPipe({
      whitelist: true,
      forbidUnknownValues: false,
    });
    const metadata: ArgumentMetadata = {
      type: 'body',
      metatype: FindConfigurationByUuidRequest,
      data: '',
    };
    await target
      .transform(<FindConfigurationByUuidRequest>{}, metadata)
      .catch((err) => {
        expect(err.message).toEqual('Rpc Exception');
      });
  });
});
